#ifndef ake_api_h
#define ake_api_h
#include <stdint.h>

#include  "lac_param.h"

//functions for ake
//Alice send: generate pk and sk, and send pk to Bob
int ake_alice_send(unsigned char *pk,unsigned char *sk, unsigned char *pk_b, unsigned char *sk_a, unsigned char *c, unsigned char *k1);
// Bob receive: receive  pk, randomly choose m, and encryrpt m with pk to generate c1 c2, k=HASH(pk,m).
int ake_bob_receive(unsigned char *pk_b, unsigned char *sk_b, unsigned char *pk_a, unsigned char *pk, unsigned char *c_in, unsigned char *c_out, unsigned char *k);
//Alice receive: receive c1,c2, and decrypt to get m and comute k=HASH(pk,m)
int ake_alice_receive(unsigned char *pk_a, unsigned char *sk_a,unsigned char *pk_b, unsigned char *pk, unsigned char *sk,  unsigned char *c_in, unsigned char *k1, unsigned char *k);

#endif /* ake_api_h */
